﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public class Number : CodeNode {
    public override int MinimumArity { get { return 0; } }
    public override int MaximumArity { get { return 0; } }

    [Storable]
    public override string Prefix { get; set; }

    [Storable]
    public override string Suffix { get; set; }

    [StorableConstructor]
    private Number(bool deserializing) : base(deserializing) { }
    private Number(Number original, Cloner cloner)
      : base(original, cloner) {
    }

    public Number()
      : base("Number", "A Number.") {
      this.Prefix = "";
      this.Suffix = "";
    }

    public override ISymbolicExpressionTreeNode CreateTreeNode() {

      return new NumberTreeNode();
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new Number(this, cloner);
    }

    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
      return " " + ((NumberTreeNode)node).Value + " ";
    }
  }
}
